/*
	Ammunation.nut - Ammunation script for Stauton Gangwar
	File Author: Force
*/

const WEP_AMMO = 250;

g_vPickupPos <- Vector( 343, -716.3, 26.43 );
g_AmmunationWeps <- [ 1, 2, 3, 4, 5, 7, 10 ];
g_AmmunationPrices <- [ 50, 50, 100, 200, 250, 300, 125 ];
g_AmmunationPickups <- [ 172, 173, 178, 176, 171, 177, 174 ];

function SendToAmmunation( pPlayer )
{
	local iID = pPlayer.ID, iWorld = iID + 1, iWeaponID = g_AmmunationWeps[ 0 ], iWeaponPrice = g_AmmunationPrices[ 0 ];
	MessagePlayer( "Welcome to Ammunation, one stop weapon shop!", pPlayer );
	MessagePlayer( "Press I or O to cycle through weapons, P to purchase and U to exit.", pPlayer );
	
	local pPickup = CreatePickup( g_AmmunationPickups[ 0 ], g_vPickupPos );
	if ( pPickup ) pPickup.VirtualWorld = iWorld;
	
	SetCameraMatrix( pPlayer, Vector( 346.8, -716.3, 26.43 ), g_vPickupPos );
	pPlayer.VirtualWorld = iWorld;
	pPlayer.Frozen = true;
	
	CallClientFunc( pPlayer, "StauntonGangwar/Client.nut", "UpdateWeaponInfo", GetWeaponName( iWeaponID ), iWeaponPrice, pPickup.ID );
	CallClientFunc( pPlayer, "StauntonGangwar/Client.nut", "AmmunationStatus", true );
}

function ShowNextWeapon( pPlayer, iSelectedWeapon, iPickupID )
{
	local iWeaponID = g_AmmunationWeps[ iSelectedWeapon ], iWeaponPrice = g_AmmunationPrices[ iSelectedWeapon ];
	
	local pPickup = FindPickup( iPickupID );
	if ( pPickup ) pPickup.Remove();
	
	local pPickup = CreatePickup( g_AmmunationPickups[ iSelectedWeapon ], g_vPickupPos );
	if ( pPickup )
	{
		pPickup.VirtualWorld = pPlayer.VirtualWorld;
		pPickup.Life = 180000;
	}
	
	CallClientFunc( pPlayer, "StauntonGangwar/Client.nut", "UpdateWeaponInfo", GetWeaponName( iWeaponID ), iWeaponPrice, pPickup.ID );
}

function ShowPreviousWeapon( pPlayer, iSelectedWeapon, iPickupID )
{
	local iWeaponID = g_AmmunationWeps[ iSelectedWeapon ], iWeaponPrice = g_AmmunationPrices[ iSelectedWeapon ];
	
	local pPickup = FindPickup( iPickupID );
	if ( pPickup )
	{
		pPickup.VirtualWorld = pPlayer.VirtualWorld;
		pPickup.Life = 180;
	}
	
	local pPickup = CreatePickup( g_AmmunationPickups[ iSelectedWeapon ], g_vPickupPos );
	if ( pPickup ) pPickup.VirtualWorld = pPlayer.VirtualWorld;
	
	CallClientFunc( pPlayer, "StauntonGangwar/Client.nut", "UpdateWeaponInfo", GetWeaponName( iWeaponID ), iWeaponPrice, pPickup.ID );
}

function PurchaseWeapon( pPlayer, iSelectedWeapon )
{
	local iWeaponID = g_AmmunationWeps[ iSelectedWeapon ], iWeaponPrice = g_AmmunationPrices[ iSelectedWeapon ];
	
	if ( pPlayer.Cash >= iWeaponPrice )
	{
		pPlayer.Cash -= iWeaponPrice;
		pPlayer.Score = pPlayer.Cash;
		pPlayer.SetWeapon( iWeaponID, WEP_AMMO );
		
		GetOnlineRank();
		FindRankPos( pPlayer );
		
		SmallMessage( pPlayer, "You have just bought a " + GetWeaponName( iWeaponID ) + " for $" + iWeaponPrice, 3000, 1 );
	}
	else SmallMessage( pPlayer, "You don't have enough money to purchase this weapon.", 3000, 1 );
}

function ExitAmmunation( pPlayer, iPickupID )
{
	local iID = pPlayer.ID;
	MessagePlayer( "You have now left ammunation, thank you and come again!", pPlayer );
	
	local pPickup = FindPickup( iPickupID );
	if ( pPickup ) pPickup.Remove();	
	
	pPlayer.VirtualWorld = 0;
	pPlayer.Frozen = false;
	
	RestoreCamera( pPlayer );
	
	CallClientFunc( pPlayer, "StauntonGangwar/Client.nut", "RemoveWeaponInfo" );
}