/*
	Staunton Gangwar - Client.nut
	File Author: Force
*/

pPlayer <- FindLocalPlayer();
vPosition <- VectorScreen( ScreenWidth - 170, ScreenHeight - 130 );
White <- Colour( 255, 255, 255 );
Green <- Colour( 0, 255, 0 );
Red <- Colour( 255, 0, 0 );

/* Ammunation stuff */
const MIN_TIME = 750;
const MAX_WEPS = 6;

bAmmunation <- false;
iLastChange <- 0;
iSelectedWeapon <- 0;
iPickupID <- -1;

function onScriptLoad()
{
	pScoreWindow <- GUIWindow( vPosition, ScreenSize( 150, 50 ), "Personal Scoreboard" );
	pPosTitleLabel <- GUILabel( VectorScreen( 5, 5 ), ScreenSize( 5, 5 ), "Pos" );
	pPosLabel <- GUILabel( VectorScreen( 40, 5 ), ScreenSize( 5, 5 ), "- N/A" );
	pScoreTitleLabel <- GUILabel( VectorScreen( 5, 25 ), ScreenSize( 5, 25 ), "Score" );
	pScoreLabel <- GUILabel( VectorScreen( 50, 25 ), ScreenSize( 5, 25 ), "- $0" );
	pClassInfoLabel <- GUILabel( VectorScreen( ScreenWidth - 170, ScreenHeight - 220 ), ScreenSize( 5, 5 ), "Class Name" );
	pClassWepLabel <- GUILabel( VectorScreen( ScreenWidth - 160, ScreenHeight - 200 ), ScreenSize( 5, 5 ), "Weapon Name" );
	pClassSpawnLabel <- GUILabel( VectorScreen( ScreenWidth - 160, ScreenHeight - 180 ), ScreenSize( 5, 5 ), "Spawn location" );
	
	pScoreWindow.Alpha = 200;
	pScoreWindow.Transparent = true;
	pScoreWindow.Moveable = false;
	pScoreWindow.Colour = Colour( 10, 10, 10 );
		
	pScoreWindow.AddChild( pPosTitleLabel );
	pScoreWindow.AddChild( pPosLabel );
	pScoreWindow.AddChild( pScoreTitleLabel );
	pScoreWindow.AddChild( pScoreLabel );
	
	pPosTitleLabel.TextColour = Red;
	pPosLabel.TextColour = White;
	
	pScoreTitleLabel.TextColour = Green;
	pScoreLabel.TextColour = White;
	
	pClassInfoLabel.TextColour = Red;
	pClassInfoLabel.FontSize = 14;
	pClassWepLabel.TextColour = White;
	pClassSpawnLabel.TextColour = White;
	
	AddGUILayer( pScoreWindow );
	AddGUILayer( pClassInfoLabel );
	AddGUILayer( pClassWepLabel );
	AddGUILayer( pClassSpawnLabel );
	
	BindKey( 'I', BINDTYPE_DOWN, "WeaponLeft" );
	BindKey( 'O', BINDTYPE_DOWN, "WeaponRight" );
	BindKey( 'P', BINDTYPE_DOWN, "WeaponPurchase" );
	BindKey( 'U', BINDTYPE_DOWN, "LeaveAmmunation" );
	
	print( "SGM Client script 0.2.0" );
	
	return 1;
}

function WeaponLeft()
{
	if ( ( bAmmunation ) && ( ( GetTickCount() - iLastChange ) >= MIN_TIME ) )
	{
		if ( iSelectedWeapon > 0 ) iSelectedWeapon --;
		else iSelectedWeapon <- MAX_WEPS;
		
		CallServerFunc( "StauntonGangwar/Main.nut", "ShowPreviousWeapon", pPlayer, iSelectedWeapon );
		iLastChange <- GetTickCount();
	}
}

function WeaponRight()
{
	if ( ( bAmmunation ) && ( ( GetTickCount() - iLastChange ) >= MIN_TIME ) )
	{
		if ( iSelectedWeapon < MAX_WEPS ) iSelectedWeapon ++;
		else iSelectedWeapon <- 0;
		
		CallServerFunc( "StauntonGangwar/Main.nut", "ShowNextWeapon", pPlayer, iSelectedWeapon, iPickupID );
		iLastChange <- GetTickCount();
	}
}

function WeaponPurchase()
{
	if ( ( bAmmunation ) && ( ( GetTickCount() - iLastChange ) >= MIN_TIME ) )
	{
		CallServerFunc( "StauntonGangwar/Main.nut", "PurchaseWeapon", pPlayer, iSelectedWeapon );
		iLastChange <- GetTickCount();
	}
}

function LeaveAmmunation()
{
	if ( ( bAmmunation ) && ( ( GetTickCount() - iLastChange ) >= MIN_TIME ) ) CallServerFunc( "StauntonGangwar/Main.nut", "ExitAmmunation", pPlayer, iPickupID );
}

function AmmunationStatus( bStatus )
{
	bAmmunation <- bStatus;
	if ( bStatus ) iLastChange <- GetTickCount();
}

function UpdateWeaponInfo( szWeaponName, iWeaponCost, iID )
{
	if ( !pClassInfoLabel.Visible )	pClassInfoLabel.Visible = true;
	if ( !pClassWepLabel.Visible ) pClassWepLabel.Visible = true;
	
	pClassInfoLabel.Text = szWeaponName;
	pClassWepLabel.Text = "- $" + iWeaponCost;
	
	iPickupID <- iID;
}

function RemoveWeaponInfo()
{
	pClassInfoLabel.Visible = false;
	pClassWepLabel.Visible = false;
	AmmunationStatus( false );
	
	iPickupID <- -1;
	iSelectedWeapon <- 0;
	iLastChange <- 0;
}

function onClientRequestClass( pClass )
{
	if ( !pClassInfoLabel.Visible )	pClassInfoLabel.Visible = true;
	if ( !pClassWepLabel.Visible ) pClassWepLabel.Visible = true;
	if ( !pClassSpawnLabel.Visible ) pClassSpawnLabel.Visible = true;
	
	local iWeapon = pClass.GetWeapon( 1 ), szWeapon = GetWeaponName( iWeapon );
	
	if ( pClass.ID <= 3 )
	{
		pClassInfoLabel.Text = "Robbers";
		pClassWepLabel.Text = "- " + szWeapon;
		pClassSpawnLabel.Text = "- Random spawn";
	}
	else if ( pClass.ID == 4 )
	{
		pClassInfoLabel.Text = "Fireman";
		pClassWepLabel.Text = "- " + szWeapon;
		pClassSpawnLabel.Text = "- Fire Station";		
	}
	else if ( pClass.ID == 5 )
	{
		pClassInfoLabel.Text = "Police";
		pClassWepLabel.Text = "- " + szWeapon;
		pClassSpawnLabel.Text = "- Police Station";		
	}
	else if ( pClass.ID == 6 )
	{
		pClassInfoLabel.Text = "Medic";
		pClassWepLabel.Text = "- " + szWeapon;
		pClassSpawnLabel.Text = "- Hospital";		
	}
	
	return 1;
}

function onClientSpawn( pClass )
{
	pClassInfoLabel.Visible = false;
	pClassWepLabel.Visible = false;
	pClassSpawnLabel.Visible = false;
	
	return 1;
}

function UpdateScore( iPos, iScore )
{
	pPosLabel.Text = "- " + iPos;
	pScoreLabel.Text = "- $" + iScore;
}